#ifndef NFC_H
#define NFC_H

#include <PubSubClient.h>
#include <Pins.h>
#include <Wire.h>
#include <Adafruit_PN532.h>

#define APDU_BUFFER_SIZE 256

class NFC
{
private:
    uint8_t uid[7];    // Buffer to hold the card's UID (PN532 supports up to 7 bytes for ISO14443A)
    uint8_t uidLength; // Length of the UID (will be set by readPassiveTargetID)
    byte pcb = 0x0A;
    byte cid = 0x00;
    bool cardSelected = false;

public:
    Adafruit_PN532 *rfid;
    NFC(int pin_sda, int pin_scl);
    bool testNFC();
    bool checkforCard();
    bool connecttoCard();
    bool disconnectCard();
    bool testCard();
    bool hasCardSelected();
    String getUID();
};

#endif
